:userdoc.
:title.PMSEEK Help
:h1.Description
:p.
:hp3.PMSEEK - An OS/2 File and Text Search Program
:ehp3.
:p.
PMSEEK lets you quickly search one or more disks (including drives on a
LAN) for files or text.
Any matches found are displayed in a listbox, and
can be browsed, edited, or
executed, by double clicking on list items.  You can also
execute commands (Copy, Erase, etc) against
files that are found.
:p.
When you search for files or data, it's usually because you want to do
something with the files that you find.  PMSEEK makes it easy by providing
drag and drop support to other applications, and by allowing you to execute
commands against files that it finds.
:p.:hp6.See Also:
:ehp6.
:link refid=r9 reftype=hd.
PMSEEK Command Syntax,
:elink.
:link refid=r7 reftype=hd.
 Searching for Filenames,
:elink.
:link refid=r6 reftype=hd.
 Searching for Text
:elink.
.*
:h1 id=r9.PMSEEK Command Syntax
:p.
You may pass search arguments when you start PMSEEK.  If you do so,
PMSEEK will immediately begin searching for files or data.
Otherwise, it will
merely display as an icon or window
(depending on your PMSEEK Default settings),
and will wait for your input.
:p.
:hp2.PMSEEK Command Syntax:
:ehp2.
:p.
        PMSEEK <filespec text>
:p.
:hp6.Where:
:ehp6.
:sl.
:li.:hp6.filespec:ehp6. is the d&colon.\path\filename.ext that you wish to search
for.  It may
be anything that would be a valid entry in the
:link refid=r7 reftype=hd.
"Filename to Search For"
:elink.
field.
:li.:hp6.text:ehp6. is any text you wish to search for within the found files.
It may
be any single search argument that would be a valid entry in the
:link refid=r6 reftype=hd.
"Text to Search For"
:elink.
field.
:esl.
.*
:h1.PMSEEK Function Keys
:p.
Within the PMSEEK window,
several function keys are supported for
users who do not wish to use the mouse:
:sl.
:li.:hp2.F1:ehp2. displays online help.
:li.:hp2.F2:ehp2. saves the contents of the "Files Found" list to disk.
:li.:hp2.F5:ehp2. clears the "Filename to Search For" field, and moves the
cursor to the field.
:li.:hp2.F6:ehp2. clears the "Text to Search For" field, and moves the
cursor to the field.
:li.:hp2.F10:ehp2. displays the PMSEEK system menu.
:li.:hp2.Alt:ehp2. displays the PMSEEK system menu.
:li.:hp2.Enter:ehp2. performs the same function as the "Search" button.
:li.:hp2.Esc:ehp2. performs the same function as the "Cancel" button.
It will cancel a search, or minimize the window (if no search is active).
:li.:hp2.Tab:ehp2. moves focus between the different window fields and buttons.
:li.:hp2.PgUp:ehp2. will PgUp within an active "Files Found" list (listbox
must have input focus).
:li.:hp2.PgUp:ehp2. will PgDn within an active "Files Found" list (listbox
must have input focus).
:li.:hp2.Space:ehp2. selects or deselects "Files Found" list items (listbox
must have input focus).
:li.:hp2.Alt-F4:ehp2. terminates PMSEEK.
:esl.
:p.
:hp6.Note:
:ehp6.Not all of the function keys will work on OS/2 v1.2.
.*
:h1.PMSEEK Main Window Controls
:p.The PMSEEK main window consists of a number of entry fields, buttons,
option selections, and a "Files Found" listbox.
.*
:h2 id=r2.Current Search Options
:p.
:hp6.Search Subdirs:
:ehp6.
When the "Search SubDirs" option is checked, all subdirectories
in the search path will be searched for the file.  If it is not checked,
only the subdirectory contained in the search argument will be searched.
:p.
:hp6.Display Found Text:
:ehp6.
If the "Display Found Text" option is checked, data found as part of
a text search will be displayed above the entry showing the filename that
the text was found in.  If this option is enabled, the search will
be somewhat slower than when it is not, because PMSEEK must search
to the end of all qualifying files in order to find and display all
occurances of the text within the files.
:p.
:hp6.Ignore Case:
:ehp6.
If the "Ignore Case" option is
checked, then any text searches will not be sensitive to upper/lower case.
:p.
:hp2.Initial Search Option Defaults
:ehp2.
:p.
The default search options are to Search Subdirs, to ignore case, and to
not display found text.  You may change the PMSEEK defaults by selecting
:link refid=r8 reftype=hd.
"Set PMSEEK Defaults"
:elink.
from PMSEEK's system menu.
.*
:h2 id=r3.Action on Double-Click
:p.
The radio buttons within the "Action on Double-Click" box, allow you
to control what action PMSEEK will take when you double-click on
lines within the "Files Found" listbox.  Only one radio-button can
be selected at a time.
:p.
:hp2.
The following "Actions" are provided:
:ehp2.
:p.
:hp6.Browse:
:ehp6.
If the Browse radio button is selected, when you double-click on lines
in the "Files Found" listbox, the BROWSE program will be executed against
the selected files.
:p.
:hp6.Edit:
:ehp6.
If the Edit radio button is selected, when you double-click on lines
in the "Files Found" listbox, your default editor will be invoked to edit
the selected files.
:p.
If your editor is EPM, and you double-click on a text string (rather than
the filename), PMSEEK will attempt to tell EPM to do a locate on that
string.  This usually works, but is not completely perfected, so there
may be times when EPM does not come up with the cursor under the string
that you clicked on.
:p.
:hp6.Execute:
:ehp6.
If the Execute radio button is selected, when you double-click on lines
in the "Files Found" listbox, PMSEEK will attempt to execute the files.
:p.
:hp6.Command:
:ehp6.
The command option allows you to execute a command against any filename
that you double-click on.  This option is explained more fully under the
heading
:link refid=r1 reftype=hd.
"Executing Commands against selected files".
:elink.
.*
:h2 id=r4."Files Found" Listbox:
:p.
Double-clicking on any filename or text that gets listed results in the
currently selected action (Browse, Edit, Execute, or Command) being
performed against the filename.  Note that you can double click on a
filename even as the search for additional filenames continues...  the
action will be performed, and the remainder of the search will continue
in the background.  The Browse, Edit, Execute, and Command functions are
all run in separate OS/2 sessions independent of PMSEEK, courtesy of
OS/2 multi-tasking support.
:p.
PMSEEK uses a
"multiple selection" listbox.  This means that more than one item can be
selected by single-clicking on multiple listbox items, then
double-clicking on the last item selected.  After double-clicking, PMSEEK
will attempt to perform the currently selected action against all of the
selected files.
Single-clicking on a
previously selected listbox item will de-select it.
.*
:h2 id=r5.Push Buttons
:p.
:hp2.Search Button
:ehp2.
:p.
When you click on the Search button, PMSEEK will read any text that
you entered into the two entry fields, clear the listbox, and begin
searching for files and/or text.
:p.
:hp2.NoClear Button
:ehp2.
:p.
If you wish to do additional searches using the original dialog
screen, but do not wish to lose the earlier hit list, key in a new
search argument, and click on the 'NoClear' button, rather than on the
'Search' button...  the original list of files found will not be
cleared, and any new files found will be inserted into the existing
list.
:p.
:hp2.Save Button
:ehp2.
:p.
When SAVE is pressed,
all lines in the "Files Found" listbox will be written to C&colon.\SEEKSAVE.FIL.
No way is currently provided to change the name of the SAVE file.
:p.
:hp2.Cancel Button
:ehp2.
:p.
Clicking on the CANCEL button during a search will abort the search.
This can be especially helpful during extremely long, multi-disk
searches.
:p.Clicking on CANCEL when no search is being performed will cause
the PMSEEK window to minimize.
.*
:h1 id=r7.Searching for Filenames
:p.
PMSEEK is very flexible in the kinds of filename searches it allows.  In
the main PMSEEK window you will be prompted to enter the "Filename
to Search For".  You may specify the filename very exactly, or
you may use '*' as a wildcard character for flexible searches.
:p.
:hp6.Examples of valid search arguments:
:ehp6.
:sl.
:li.:hp2.C&colon.*.EXE:ehp2.
     lists all of the .EXE files on the C: drive
:li.:hp2.*&colon.E.EXE:ehp2.
     lists all occurences of E.EXE on every available drive
(including NET drives).  This search could take awhile!
:li.:hp2.ACD&colon.*.DOC:ehp2.
  search drives A: C: and D: for all .DOC files.
:li.:hp2.P*K.EXE:ehp2.
    list all .EXE files whose filenames start with P and
end with K
:li.:hp2.*.TXT:ehp2.
      list all .TXT files found on the current default drive
:li.:hp2.TEMP*:ehp2.
     lists all files with names matching TEMP*.* on the
default drive
:li.:hp2.TEMP:ehp2.
      lists all files with names matching TEMP.* on the
default drive
:li.:hp2.D&colon.\UTIL\*.EXE:ehp2.
 lists all .EXE files contained in D&colon.\UTIL or in any
subdirectories chained off D&colon.\UTIL
:esl.
:p.:hp6.See Also:
:ehp6.
:link refid=r2 reftype=hd.
Current Search Options,
:elink.
:link refid=r3 reftype=hd.
 Action on Double-Click,
:elink.
:link refid=r4 reftype=hd.
 "Files Found" Listbox,
:elink.
:link refid=r5 reftype=hd.
 Push Buttons,
:elink.
:link refid=r1 reftype=hd.
 Executing Commands against selected files,
:elink.
:link refid=r6 reftype=hd.
 Searching for Text
:elink.
.*
:h1 id=r6.Searching for Text
:p.
PMSEEK includes text search capability.  This
means that in addition to searching for filenames, you may also search for
specific text strings within the located files.  If you do not wish to
search for text strings within the found files, simply do not enter
anything in the "Enter Text to Search For" field, and PMSEEK will
merely search for filenames.
:p.
If the :hp6.Ignore Case:ehp6. search option is selected,
text searches will be case-insensitive, meaning that PMSEEK makes no
distinction between "TEXT" and "text", for example, when looking for
matches.   No special wild-cards are supported in the text search field.
If you enter more than one word search arguments, for example, "net use",
PMSEEK will search for both words, but will not find a match unless they
occur together within the text being searched.
:p.
:hp2.Text Searches using Boolean Operators:ehp2.
:p.Starting with v5.70, PMSEEK supports more complex text searches.
You may include two search arguments, separated by a boolean operator.
The supported operators are
:hp2.&amp.:ehp2. (AND),
:hp2.|:ehp2. (OR), and
:hp2.!:ehp2. (NOT).
:p.
:hp2."Proximity" Text Searches
:ehp2.
:p.Sometimes you may only wish to display hits for search arguments
that are located close to each other in the data.  For example,
You may wish to search for "Phone" but display the hit only if it
is found near a second string, say "945-".  To do this, you would
use the "proximity" operators :hp2.&amp.&amp.:ehp2. (AND) or
:hp2.!!:ehp2. (NOT)
rather than the normal AND and NOT operators.
:p.If you use the proximity operators, found text will only be
displayed when the second search condition is satisfied
within 80 characters of
the first search argument.
:p.
:hp6.Examples of Text Search Arguments with Boolean Operators:
:ehp6.
:sl.
:li.:hp2.fopen &amp. fclose:ehp2.
     find files that contain both "fopen" AND "fclose"
:li.:hp2.fopen | fclose:ehp2.
     find files that contain either "fopen" OR "fclose"
:li.:hp2.fopen ! fclose:ehp2.
     find files that contain "fopen" and do NOT contain "fclose"
:li.:hp2.net use &amp. fclose:ehp2.
     find files that contain "net use" AND "fclose"
:li.:hp2.(303) &amp.&amp. Boulder:ehp2.
   only display hits in the text that contain both "(303)" AND
"Boulder" AND "Boulder was found within 80 characters of
"(303)" in the found text.
:li.:hp2.(303) !! Denver:ehp2.
   only display text that contains both "(303)" AND
does NOT contain "Denver" within 80 characters of
"(303)" in the found text.
:esl.
:p.
:hp6.Usage Notes:
:ehp6.
:ul.
:li.If "Display Found Text" is enabled, only found text associated with the first
search argument will be displayed following AND or NOT searches.
This happens because
PMSEEK first searches for the AND or NOT argument... if that condition is
satisfied, PMSEEK then searches for the first search argument.  This results
in better search performance (the 2nd stage of the search is only done if the
boolean condition was satisfied), but by the time PMSEEK figures out if all
search conditions were satisfied, the "display text" associated with the
boolean condition is long-gone (whew).  This limitation may be removed
in a future release.
:li.The boolean operator must contain a space before and after it.  Otherwise
PMSEEK will merely treat it as part of a search argument.
:li.When starting PMSEEK and passing arguments, you should only pass one
text search argument, without a boolean operator.  This restriction may
be removed in a future release.
:li.As you might guess, complex searches with boolean arguments take
longer than simple one-argument searches.
If you are about to perform a time-consuming boolean AND or NOT search,
try putting the must unlikely argument :hp2.after:ehp2. the
:hp2.&amp.:ehp2. or
:hp2.!:ehp2..  It may decrease the search time.
:eul.
:p.
:hp6.Technical Note:
:ehp6.
:p.
PMSEEK is able to perform fairly rapid text searches by using the
following techniques to enhance performance:
:ol.
:li.PMSEEK treats all files as if they were "binary" files and
reads them in 32K data blocks, then scans the 32K block
for a match.  By using a relatively large blocksize, PMSEEK
reduces the number of individual disk I/O requests needed to
read the file into memory.
:li.Once the 32K block has been read into memory, PMSEEK uses a
variation of the Boyer-Moore string search algorithm to search for a
match.  Rather than simply doing a "brute-force" comparison, the B-M
algorithm uses a pre-built table of "mismatch" skip values.  In a
pre-processing step, we decide for each possible character value that
could occur in the text, how many text characters to skip ahead if
that character were to cause a mismatch.  We then scan the search
argument with the text from right-to-left, and if a mismatch occurs,
we then skip N characters ahead in the text (based on the skip value
found for that character in the skip table).  Use of this algorithm
results in about a 40% improvement (average)
over the old linear search method used in earlier releases of PMSEEK.
:eol.
:p.:hp6.See Also:
:ehp6.
:link refid=r2 reftype=hd.
 Current Search Options,
:elink.
:link refid=r3 reftype=hd.
 Action on Double-Click,
:elink.
:link refid=r4 reftype=hd.
 "Files Found" Listbox,
:elink.
:link refid=r5 reftype=hd.
 Push Buttons,
:elink.
:link refid=r1 reftype=hd.
 Executing Commands against selected files,
:elink.
:link refid=r7 reftype=hd.
 Searching for Filenames
:elink.
.*
:h1 id=r1.Executing Commands against selected files
:p.
You can execute commands (ie. Copy, Erase
Rename, etc) against files that you double-click on.  In the main PMSEEK
window there is a radio button labeled :hp6.Command:ehp6..  If you
select :hp6.Command:ehp6., then double-click on a file, a second dialog window
will pop-up, prompting you to enter the command you wish to execute
against the selected file(s).  If you typed 'Erase', for example, and then
clicked on the 'Enter' button, PMSEEK would then erase the selected file.
:p.
:hp2.Filename Substitution:ehp2.
:p.
Normally PMSEEK executes commands by taking the command you entered,
appending the name of the selected file to the command, then
executing the command.  However, for added flexibility, you may
specify exactly where PMSEEK is to append the filename by using the '/'
sign in the entered command.  For example if you selected file
'C&colon.\TMP\TEST.FIL', and entered the command 'COPY / C&colon.\UTIL', PMSEEK
would then issue the command 'COPY C&colon.\TMP\TEST.FIL C&colon.\UTIL', substituting
the filename for the first occurence of the '/' sign in the command
string.
.*
:h1.Drag and Drop Support
:p.PMSEEK provides drag and drop support to make it easier to interact with
other programs.  By using drag and drop, a certain amount of synergy is
obtained between programs.
:p.
:hp6.How to do it:
:ehp6.
 Start by marking (left single-click) a filename in the "Files Found" listbox,
press and hold the right mouse button, then release the button over an
EPM, PMBROWSE, or FORBROWS window or icon.  The selected file will then
be loaded into an edit or browse window.  If multiple filenames are
marked, PMSEEK will attempt to send all of the marked filenames, one after
the other, to the
"dropped-on" window.
:p.
:hp6.A new mouse pointer is displayed when drag and drop is active.
:ehp6.
 When PMSEEK realizes that you've pressed the right mouse button for drag
and drop, the mouse pointer will change to indicate that drag-and-drop
is active.
:p.
:hp6.Technical Note:
:ehp6.
 PMSEEK's implementation of drag and drop uses the same conventions as
the OS/2 File Manager for message passing, etc.  At present, the only
applications that are known to work with PMSEEK's drag and drop are
EPM, PMBROWSE, FORBROWS, and CommMgr.  You must have the
appropriate versions of
EPM, PMBROWSE, or FORBROWS for the drag and drop support to work.
PMSEEK can only be a
"dropp-er"...  not a "drop-ee" (ie.  PMSEEK will not do anything useful
if dropped-on from another application).
:p.
:hp2.Uploading via Drag and Drop to OS/2 Comm Mgr 3270 Window:
:ehp2.
:p.
PMSEEK also allows you to drop on the CommMgr 3270 windows.
When you do so, PMSEEK attempts to upload the first marked file to the
VM session A-disk (PMSEEK does not speak TSO).  PMSEEK understands that
certain .EXTs signify binary files, and uploads accordingly.  There is
currently no way to alter PMSEEK's upload parameters.
:p.
:hp6.Note:
:ehp6.PMSEEK will only drop one filename at a time
onto a CommMgr 3270 window.  This is
because the upload program (SEND.EXE) establishes a session with the host
system that you are uploading to, and can only send one file at a time.
If PMSEEK were to send
multiple filenames to the 3270 window,
the first marked file in the list would upload successfully, but
the rest of the uploads would probably to fail.
.*
:h1 id=r8.Setting PMSEEK Start-up Defaults
:p.
To customize the start-up
options, select "Set PMSEEK Defaults" from PMSEEK's system menu.
You can display PMSEEK's system menu by pressing the "Alt" key from
within the PMSEEK main window.
A dialog
box will be displayed, showing the current PMSEEK start-up
defaults stored in
OS2.INI.  While in the "Defaults" dialog, clicking on the "Save" button
will cause PMSEEK to save all values to OS2.INI.
:p.
While in the "Defaults" dialog, you may set the names of the the
editor and browser you wish to use when double-clicking in the
"Files Found" listbox.  Generally, the editor or browser should be
a .EXE or .CMD file.  When PMSEEK is first installed, it defaults
to using E.EXE (the system editor) as both the editor and browser.
:p.
:hp2.Using PMBROWSE.DLL as the Browser:ehp2.
:p.
If you specify PMBROWSE.DLL in the "Browse Program Filespec" field,
PMSEEK will invoke PMBROWSE via its API.  The advantage of this
approach is that PMSEEK is able to start the browser much more
quickly.  Note that PMBROWSE.DLL will need to reside in a
subdirectory that is within your LIBPATH.
.*
:h1.Animated Icons and Bitmaps in PMSEEK
:p.
:hp2.Animated Icon:ehp2.
:p.
PMSEEK's client area contains an animated icon.  The icon shifts
its eyes back and forth as you move the mouse pointer across the
client area.  :hp3.Why?:ehp3. The animated icon simulates the
:hp2.seeking:ehp2. that PMSEEK does when looking for files and
data.
:p.
:hp2.Animated "About" Bitmap Image:ehp2.
:p.
As an experiment,
the PMSEEK author decided it would be
interesting to display an animated photograph as part
of the "About" information.
In order to be consistent with the animated client-area icon,
the eyes in the "About" photograph were also animated.
This was done by copying the original bitmap image, then using the icon
editor from the PM programmer's toolkit to create some shifty
eyes.
PMSEEK merely alternates the two bitmaps (one with eyes straight
ahead, the other with eyes shifted) during the display of "About"
information.
.*
:h1.PMSEEK Limitations
:p.
PMSEEK can only display 64K bytes of information in the "Files Found"
listbox.  This is due to a Presentation Manager restriction on the
amount of data a listbox can hold.
.*
:h1.PMSEEK Installation
:p.
Only two files, PMSEEK.EXE and PMSEEK.INF, are needed in order
to run PMSEEK.
PMSEEK.INF contains on-line help information
(the file you are currently viewing).  It should either be installed
in the same subdirectory as PMSEEK.EXE, or in a subdirectory within
your DPATH.
:p.
If PMSEEK.INF is not installed properly, PMSEEK will run,
but the on-line Help will not work.
:p.
The on-line Help information within PMSEEK.INF can be displayed
by choosing one of the Help functions within PMSEEK (F1 or clicking
on the Help Button), or by using OS/2's VIEW program.
:euserdoc.
